package it.unipd.app;


public class Frame {

    private int rollsNumber;
    private int pinsNumber;
    private Roll[] rolls;
    private int currentRoll = 0;

    public Frame(int maxRoll, int maxPin) {
        rollsNumber = maxRoll;
        pinsNumber = maxPin;
        rolls = new Roll[maxRoll];
        for (int i = 0; i < maxRoll; i ++)
            rolls[i] = new Roll();
    }

    public int getCurrentRoll() {
        return currentRoll;
    }

    public void roll(int pins) {
        rolls[currentRoll].setPins(pins);
        checkScore();
        addARoll();
    }

    public int getRollScore(int getPosition) {
        return rolls[getPosition].getPins();
    }

    public boolean isStrike() {
        return rolls[0].getPins() == getPinsNumber();
    }

    public boolean isSpeare(){
        return rolls[0].getPins() + rolls[1].getPins() == getPinsNumber();
    }

    public boolean finish() {
        return getCurrentRoll() == getRollsNumber() || isStrike();
    }

    public int sumOfPinsInFrame() {
        int score = 0;
        if (isStrike())
            score = pinsNumber;
        else {
            for (int i = 0; i < getRollsNumber(); i++)
                score += getRollScore(i);
        }
        return score;
    }

    private void addARoll() {
        currentRoll ++;
    }

    protected void checkScore(){
        if (sumOfPinsInFrame() > getPinsNumber()) {
            throw new RuntimeException("Score out of range");
        }
    }

    protected int getPinsNumber() {
        return pinsNumber;
    }

    protected int getRollsNumber() {
        return rollsNumber;
    }
}
