package it.unipd.app;

public class LastFrame extends Frame {
    private Roll[] bonusRolls;
    private int currentBonusRoll = 0;

    public LastFrame(int maxRoll, int Pins) {
        super(maxRoll, Pins);
    }

    public void roll(int pins) {
        if(isStrike() || isSpeare()) {
            bonusRolls[currentBonusRoll].setPins(pins);
            addABonusRoll();
        }
        else {
            super.roll(pins);
        }
        if (isStrike() && bonusRolls == null)
            createBonusRolls(2);
        if (isSpeare() && bonusRolls == null)
            createBonusRolls(1);
    }

    public boolean finish() {
        return super.finish() && bonusRollsIsFinish();
    }

    public int getRollScore(int getPosition) {
        int score = 0;
        if (isStrike() && getPosition > 0) {
            score = bonusRolls[getPosition -1].getPins();
        } else {
            if (isSpeare() && getPosition > 1) {
                score = bonusRolls[getPosition - 2].getPins();
            } else {
                score = super.getRollScore(getPosition);
            }
        }
        return score;
    }

    private boolean bonusRollsIsFinish() {
        return bonusRolls == null || currentBonusRoll == bonusRolls.length;
    }

    private void createBonusRolls(int size) {
        bonusRolls = new Roll[size];
        for (int i = 0; i < size; i++)
            bonusRolls[i] = new Roll();
    }

    private void addABonusRoll() {
        currentBonusRoll ++;
    }
}
