package it.unipd.app;

import java.util.ArrayList;

public class MultiplayerBowlingGame {

    private ArrayList<BowlingGameInterface> playersGame;
    private ArrayList<String> playersName;
    private int currentPlayerIndex = 0;
    
    public MultiplayerBowlingGame() {
        playersGame = new ArrayList<BowlingGameInterface>();
        playersName = new ArrayList<String>();
    }

    public void addPlayer(String playerName, 
            BowlingGameInterface bowlingGame) {
        playersGame.add(bowlingGame);
        playersName.add(playerName);
    }

    public boolean finish() {
        boolean finish = true;
        for (int i = 0; i < playersGame.size(); i++) {
            finish = finish && playersGame.get(i).finish();
        }
        return finish;
    }

    public void roll(int i) {
        int currentFrame = playersGame.get(currentPlayerIndex).getFramePosition();
        playersGame.get(currentPlayerIndex).roll(i);
        if (currentFrame != playersGame.get(currentPlayerIndex).getFramePosition())
            currentPlayerIndex = (currentPlayerIndex + 1) % playersGame.size();
    }

    public String getWinner() {
        int topScore = Integer.MIN_VALUE;
        int topPlayerIndex = 0;
        for (int i =0; i < playersGame.size(); i++)
            if (topScore < playersGame.get(i).score()){
                topPlayerIndex = i;
                topScore = playersGame.get(i).score();
            }
        return playersName.get(topPlayerIndex);
    }
    
    public int getWinnerScore() {
        int topScore = Integer.MIN_VALUE;
        for (int i =0; i < playersGame.size(); i++)
            if (topScore < playersGame.get(i).score()){
                topScore = playersGame.get(i).score();
            }
        return topScore;
    }
}

