package it.unipd.app;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class DataFromFile {

    private String line;
    private int expected;
    private BufferedReader reader;

    public DataFromFile(String fileName) throws Exception {
        reader = new BufferedReader(
                new InputStreamReader(
                        getClass().getResourceAsStream( fileName)));
    }

    public int getExpected() {
        return expected;
    }

    public int[] getDataFromFile()throws Exception {
        int[] arguments = null;
        while ((line = reader.readLine()) != null) {
            if(line.startsWith("#")){
                continue;
            }
            StringTokenizer st = new StringTokenizer (line);
            if (!st.hasMoreTokens()){
                continue; //Blank line
            }
            // Get expected value
            String val = st.nextToken();
            expected = Integer.valueOf(val).intValue();
            // And the arguments
            ArrayList <Integer> argument_list = new ArrayList <Integer> ();
            while (st.hasMoreTokens()){
                argument_list.add(Integer.valueOf(st.nextToken()));
            }
            arguments = new int[argument_list.size()];
            for (int i=0; i < argument_list.size(); i++) {
               arguments[i] = ((Integer)argument_list.get(i)).intValue();
            }
            break;
        }
        return arguments;
    }
}
