package it.unipd.app;

import junit.framework.TestCase;
import static org.easymock.EasyMock.*;

public class MultiplayerBowlingGameTest extends TestCase {

    public MultiplayerBowlingGameTest(String name) {
        super(name);
    }

    public void testGetWinnerScore() {
        // create player1
        BowlingGameInterface mockPlayer1 = 
            createMock(BowlingGameInterface.class);
        expect(mockPlayer1.score()).andReturn(30).atLeastOnce();
        replay(mockPlayer1);
        
        MultiplayerBowlingGame mpGame = new MultiplayerBowlingGame();
        mpGame.addPlayer("player1", mockPlayer1);
        assertEquals(30, mpGame.getWinnerScore());
        verify(mockPlayer1);
    }

    public void testGetWinner() {
        MultiplayerBowlingGame mpGame = new MultiplayerBowlingGame();
        String player1Name = "player 1";
        String player2Name = "player 2";
        mpGame.addPlayer(player1Name, new MockBowlingGame());
        mpGame.addPlayer(player2Name, new MockBowlingGame());
        while (!mpGame.finish()) {
            mpGame.roll(1);
            mpGame.roll(2);
        }
        assertEquals(player2Name, mpGame.getWinner());
    }
    
}
